( Beispielprogramm fr ISYS-Vocabulary )
( fr speicherresidente Programme      )
( Autor: Erwin Schomburg               )

include forth
include isys

( es folgt ein kleines Beispiel, wie man  )
( dem Drucker ein X fr ein U vormacht... )

constant CHA1          0       ( Druckerkanal: LPT1            )
constant PRINTER     $17       ( Interrupt Parallelport        )
constant PARPRT        0       ( Subfunkt. 'Zeichen an Drucker')

variable oldint        0
variable pproc         0

: printproc
beginint                       ( Register sichern              )

 dx @ CHA1 = if                ( wird LPT1 angesprochen?       )
  ax @ dup
  $ff00 and PARPRT = if        ( Kommando 'Zeichen drucken?    )

    $00ff and 'U' = if         ( ist Zeichen = 'U'?  dann      )
     ax @ $ff00 and 'X' + ax ! ( ein 'X' fr ein 'U' vormachen )
    endif
  endif
 endif
 oldint exitto                 ( Originalen Druckerinterrupt   )
                               ( anspringen                    )
;


: main
 hex
 ." Drucker Interrupt Umleitung von " cr
 PRINTER oldint dup makevect  ( Variable als Vektor-   )
                              ( Pointer vorbereiten,   )
 getvect                      ( Druckerinterrupt-      )
                              ( Vektor holen           )
                              ( und sichern            )

 oldint dup
 vecthi @ 4 u.r ." :"
 vectlo @ 4 u.r
 pproc makevect
 cs@ pproc vecthi !  ( eigenes Codesegment    )
                     ( holen und als HI Wort  )
                     ( des Pointers setzen    )

 find printproc      ( Wortadresse suchen     )
 pproc vectlo !      ( und als LO Wort des    )
                     ( Pointers setzen        )

 PRINTER pproc setvect  ( Interruptvektor auf    )
                        ( eigene Prozedur setzen )
 ."  nach "
 pproc dup
 vecthi @ 4 u.r ." :"
 vectlo @ 4 u.r cr
 ." bentigt (Hex) "
 s0 @ 4 u.r ."  Bytes" cr
 keep     ( Programm resident      )
          ( machen                 )
;
