( Demo zum String-Vocabulary von SForth 3.1 )

include forth
include string

variable a$ 0
variable b$ 0

: init
  a$ 80 string
  b$ 80 string
  ." ** String-Demo SForth 3.1 **" cr cr
  ." Bitte geben Sie einen Text ein: " query cr
;

: ausgabe
  a$ len 1
  do
    a$ i + c@  ( Zeichen aus String holen )
    emit bl emit  ( Zeichen und Leerzeichen ausgeben )
  loop cr
;

: links
  b$ len 1
  do
    b$ a$ $!   ( a$ restaurieren )
    a$ i left$ ( Zeichenkette erzeugen )
    a$ $. cr   ( ...und ausgeben )
  loop
;

: rechts
  b$ len 1
  do
    b$ a$ $!    ( a$ restaurieren )
    a$ i right$ ( Zeichenkette erzeugen )
    a$ $. cr    ( ...und ausgeben )
  loop
;

: main
  init
  tib @ a$ $!  ( Text in a$ speichern )
  a$ b$ $!     ( ...und in b$ )
  links rechts
  cr ." Sie haben eingegeben: " cr ausgabe
  ." ... und das war's !" cr
;

