( String-Vocabulary fr SForth, Version 3.1 )

( **  Achtung ! Vorlufige Testversion, noch nicht dokumentiert )
( **  und ausgetestet. Vorschlge und Ergnzungen bitte an die  )
( **  Redaktion DOS International, zu Hnden Volker Everts      )


include forth

vocabulary string


: string ( str n --> )
  here swap  ( Adresse holen und merken )
  0 c,       ( Count-Byte initialisieren )
  allot      ( Platz fr String reservieren )
  swap 3 - ! ( Variablenaufruf patchen )
;


: len ( str --> n )
  c@
;


: $. ( str --> )
  count type
;


: $! ( str1 str2 --> )
  over len 1+ cmove  ( str1 an Position str2 speichern )
;


: $+ ( str1 str2 --> )  ( str1 an Ende von str1 anhngen )
  swap count >r ( Lnge retten )
  over count +  ( Stringende )
  r cmove       ( Bytes kopieren )
  dup len r> +  ( neue Lnge )
  swap c!       ( eintragen )
;


: left$ ( str n --> )  ( n linke Zeichen von str )
  over len min  ( neue Lnge )
  swap c!       ( eintragen )
;


: mid$ ( str pos n --> )  ( n Zeichen von str ab pos )
  >r over len   ( Stringlnge )
  ddup >        ( pos > len ? )
  if
    drop drop   ( pos, len )
    0 swap c!   ( Leerstring )
  else
    over -      ( len - pos )
    r> min >r   ( neue Lnge )
    over +      ( Quelle )
    over 1+     ( Ziel )
    r cmove     ( kopieren )
    r> swap c!  ( neue Lnge )
  endif
;


: right$ ( str n --> )  ( die n letzten Zeichen von str )
  over len min  ( Lnge festlegen )
  >r dup len    ( aktuelle Lnge )
  r - over + 1+ ( Quelle )
  over 1+       ( Ziel )
  r cmove       ( kopieren )
  r> swap c!    ( neue Lnge )
;


: clr$ ( str --> )  ( Leerstring erzeugen )
  0 swap c!
;


: val ( str --> n )  ( String in Zahl wandeln )
  number drop
;


: str$ ( n --> str )  ( Zahl in String wandeln )
  s->d       ( doppeltgenaue Zahl erzeugen )
  swap over  ( Vorzeichen-Byte )
  dabs       ( Absolutwert )
  <# # #s    ( Zahlenstring erzeugen )
  sign #>    ( Vorzeichen )
  over 1- c! ( Count-Byte ablegen )
  1-
;


: $= ( str1 str2 --> flag )
  over c@ over c@ min  ( Anzahl Vergleiche )
  dup 0
  do
    drop
    over c@ over c@    ( Bytes holen )
    = not              ( ungleich ? )
    if
      false leave      ( Schleife verlassen )
    else
      1+ swap 1+ swap  ( Adressen erhhen )
      true             ( True-Flag )
    endif
  loop
  rot drop swap drop   ( Adressen vernichten )
;


: $pos ( str c --> n )
  over len dup 1 ( Schleifengrenzen )
  do
    drop
    over i +     ( Zeichen adressieren )
    c@ over =    ( Zeichen gefunden ? )
    if
      i leave    ( Zhler merken )
    else
      0
    endif
  loop
  rot drop swap drop
;


: nfa ( str --> adr )  ( Namensfeldadresse aus Namen )
  $108             ( Beginn Dictionary-Link )
  begin
    dup 2+         ( zeigt auf Name )
    3 pick $= not  ( String mit Namen vergleichen )
    while
      @            ( neuen Zeiger holen )
      dup @ 0=     ( Dictionary-Ende ? )
      if
        drop false ( ja, Rckkehr mit Null )
        exit
      endif
  repeat
  2+               ( Namensfeldadresse bilden )
;


: cfa ( adr1 --> adr2 )  ( Codefeldadresse aus nfa bilden )
  count + 1+
;


(save.voc)


: main
;
