( Demo zum System-Vocabulary von SForth 3.1 )

include forth
include system


: anzeigen
  bl leading ! ( fhrende Leerzeichen whlen )
  doserr @  ( Fehlerstatus holen )
  if
    ." Keine (weiteren) Dateien vorhanden"
    true
  else
    fname count type  ( Dateinamen zeigen )
    12 tab
    flen 8 d.r        ( Dateilnge ausgeben )
    ."  Byte  "
    fdate dup         ( Dateidatum holen )
    $1F and           ( Tag isolieren )
    2 u.r '.' emit    ( und drucken )
    5 shr dup $0F and ( Monat isolieren )
    2 u.r  '.' emit   ( und drucken )
    4 shr             ( Jahr isolieren )
    1980 + .          ( und drucken )
    false             ( Flag hinterlassen )
  endif
  cr
;


: main
  ." Directory von Laufwerk "
  ?drive     ( Laufwerksnummer holen )
  65 +       ( in Buchstaben wandeln )
  emit       ( ...und ausgeben )
  ':' emit   ( Doppelpunkt anhngen )
  cr cr
  ." Volume ist "
  " *.* " 8 firstfile  ( Volume suchen )
  doserr @  ( Fehlerstatus holen )
  if
    ." nicht vorhanden" ( kein Volume )
  else
    fname count type ( sonst Namen ausgeben )
  endif
  cr cr
  " *.* " 0 firstfile ( Dateien suchen )
  anzeigen
  if 1 halt endif
  begin
    nextfile
    anzeigen
  until
;